import { Selector } from 'testcafe';
import { AddDeviceBase, DeviceIds } from '../pictory/pictory.models';

fixture`export_pictory_rsc_format`;

test('Export PiCtory rsc format', async (t) => {
  await AddDeviceBase(DeviceIds.Core3);
  await t
    .hover('#file')
    .click('#file_export')
    .click('#rdoExport')
    .expect(
      Selector('#tblExportData b').withText('PiCtory project file').textContent,
    )
    .eql('PiCtory project file')
    .click('#rdoExportModeShow')
    .click(Selector('span').withText('Ok'))
    .expect(Selector('#taShowExport').textContent)
    .contains('{"App":{"name": "PiCtory", "version": ')
    .expect(Selector('#taShowExport').textContent)
    .contains('"type": "BASE","productType": "95","position": "0","name": ');
});
