import { Selector } from 'testcafe';
import { AddDeviceBase, AddDeviceRight, DeviceIds } from '../pictory/pictory.models';

fixture`PiCtory VAL files`;

test('DIO val-file', async (t) => {
  await AddDeviceBase(DeviceIds.Core3);
  await AddDeviceRight(DeviceIds.DIO);
  await t
    .expect(Selector('#tblEdit_attrvalue_sel_75').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_76')
    .click(Selector('#tblEdit_attrvalue_sel_76 option').withText('Encoder'))
    .expect(Selector('#tblEdit_attrvalue_sel_75').value)
    .eql('3')
    .expect(Selector('#tblEdit_attrvalue_sel_77').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_79')
    .click(Selector('#tblEdit_attrvalue_sel_79 option').withText('Encoder'))
    .expect(Selector('#tblEdit_attrvalue_sel_80').value)
    .eql('3')
    .expect(Selector('#tblEdit_attrvalue_sel_78').value)
    .eql('0')
    .expect(Selector('#tblEdit_attrvalue_sel_81').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_81')
    .click(
      Selector('#tblEdit_attrvalue_sel_81 option').withText(
        'Counter, rising edge',
      ),
    )
    .expect(Selector('#tblEdit_attrvalue_sel_81').value)
    .eql('1')
    .click('#tblEdit_attrvalue_sel_82')
    .click(
      Selector('#tblEdit_attrvalue_sel_82 option').withText(
        'Counter, falling edge',
      ),
    )
    .expect(Selector('#tblEdit_attrvalue_sel_82').value)
    .eql('2')
    .click('#tblEdit_attrvalue_sel_83')
    .click(
      Selector('#tblEdit_attrvalue_sel_83 option').withText(
        'Counter, rising edge',
      ),
    )
    .click('#tblEdit_attrvalue_sel_84')
    .click(
      Selector('#tblEdit_attrvalue_sel_84 option').withText(
        'Counter, rising edge',
      ),
    )
    .click('#tblEdit_attrvalue_sel_85')
    .click(Selector('#tblEdit_attrvalue_sel_85 option').withText('Encoder'))
    .expect(Selector('#lblDialogInfo').textContent)
    .eql(
      'ERR: number of counter values is too high (max: 6; Encoder-pairs only count as one)',
    )
    .click(Selector('span').withText('Ok'))
    .expect(Selector('#tblEdit_attrvalue_sel_85').value)
    .eql('0')
    .expect(Selector('#tblEdit_attrvalue_sel_86').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_80')
    .click(Selector('#tblEdit_attrvalue_sel_80 option').withText('Direct'))
    .expect(Selector('#tblEdit_attrvalue_sel_79').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_75')
    .click(Selector('#tblEdit_attrvalue_sel_75 option').withText('Direct'))
    .expect(Selector('#tblEdit_attrvalue_sel_76').value)
    .eql('0');
});

test('DI val-file', async (t) => {
  await AddDeviceBase(DeviceIds.Core3);
  await AddDeviceRight(DeviceIds.DI);
  await t
    .expect(Selector('#tblEdit_attrvalue_sel_42').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_43')
    .click(Selector('#tblEdit_attrvalue_sel_43 option').withText('Encoder'))
    .expect(Selector('#tblEdit_attrvalue_sel_42').value)
    .eql('3')
    .expect(Selector('#tblEdit_attrvalue_sel_44').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_46')
    .click(Selector('#tblEdit_attrvalue_sel_46 option').withText('Encoder'))
    .expect(Selector('#tblEdit_attrvalue_sel_47').value)
    .eql('3')
    .expect(Selector('#tblEdit_attrvalue_sel_45').value)
    .eql('0')
    .expect(Selector('#tblEdit_attrvalue_sel_48').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_48')
    .click(
      Selector('#tblEdit_attrvalue_sel_48 option').withText(
        'Counter, rising edge',
      ),
    )
    .expect(Selector('#tblEdit_attrvalue_sel_48').value)
    .eql('1')
    .click('#tblEdit_attrvalue_sel_49')
    .click(
      Selector('#tblEdit_attrvalue_sel_49 option').withText(
        'Counter, falling edge',
      ),
    )
    .expect(Selector('#tblEdit_attrvalue_sel_49').value)
    .eql('2')
    .click('#tblEdit_attrvalue_sel_50')
    .click(
      Selector('#tblEdit_attrvalue_sel_50 option').withText(
        'Counter, rising edge',
      ),
    )
    .click('#tblEdit_attrvalue_sel_51')
    .click(
      Selector('#tblEdit_attrvalue_sel_51 option').withText(
        'Counter, rising edge',
      ),
    )
    .click('#tblEdit_attrvalue_sel_52')
    .click(Selector('#tblEdit_attrvalue_sel_52 option').withText('Encoder'))
    .expect(Selector('#lblDialogInfo').textContent)
    .eql(
      'ERR: number of counter values is too high (max: 6; Encoder-pairs only count as one)',
    )
    .click(Selector('span').withText('Ok'))
    .expect(Selector('#tblEdit_attrvalue_sel_52').value)
    .eql('0')
    .expect(Selector('#tblEdit_attrvalue_sel_53').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_45')
    .click('#tblEdit_attrvalue_sel_47')
    .click(Selector('#tblEdit_attrvalue_sel_47 option').withText('Direct'))
    .expect(Selector('#tblEdit_attrvalue_sel_46').value)
    .eql('0')
    .click('#tblEdit_attrvalue_sel_42')
    .click(Selector('#tblEdit_attrvalue_sel_42 option').withText('Direct'))
    .expect(Selector('#tblEdit_attrvalue_sel_43').value)
    .eql('0');
});
